#include "Player.h"
#include "Game.h"

Player::Player( Framework::Vec3<float> location, int dimensionId, int entityId )
    : Entity( PlayerEntityType::INSTANCE, location, dimensionId, entityId )
{
    maxHP = 10;
    currentHP = 10;
    stamina = 10;
    maxStamina = 10;
    hunger = 10;
    maxHunger = 10;
    thirst = 10;
    maxThirst = 10;
}

void Player::setName( Framework::Text name )
{
    this->name = name;
}

const char *Player::getName() const
{
    return name;
}

void Player::api( Framework::StreamReader *zRequest, NetworkResponse *zResponse )
{
    // TODO: answer API calls
}

PlayerEntityType::PlayerEntityType()
    : EntityType( ID )
{}

void PlayerEntityType::loadSuperEntity( Entity *zEntity, Framework::StreamReader *zReader ) const
{}

void PlayerEntityType::saveSuperEntity( Entity *zEntity, Framework::StreamWriter *zWriter ) const
{}

Entity *PlayerEntityType::createEntity( Framework::Vec3<float> position, int dimensionId, Game *zTarget, int entityId ) const
{
    return new Player( position, dimensionId, entityId );
}